unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
* [PATCH] completion: complete bash completion rewrite
@ 2013-03-02 13:59 Jani Nikula
  2013-03-03 20:59 ` [PATCH v2] " Jani Nikula
  0 siblings, 1 reply; 3+ messages in thread
From: Jani Nikula @ 2013-03-02 13:59 UTC (permalink / raw)
  To: notmuch

Rewrite the bash completion script to actually do something
useful. There are still a few rough edges (documented as BUGS/TODO),
but it's already fairly good.

In addition to completing all the notmuch keyword arguments, it does
some nice stuff, like complete tags on 'notmuch tag (+|-)<TAB>' and
config options on 'notmuch config (get|set) <TAB>'.

This is all based on the bash-completion package [1], and will not
work without it.

[1] http://bash-completion.alioth.debian.org/

---

CAVEATS:

This is pretty much "good enough" for me. The existing one was, IMHO,
practically useless.

There may be dependencies on the version of the bash-completion
package. I do not know, and I don't have a huge interest in finding
out. That way lay dragons.

Regardless, I think this is a *huge* improvement on the status quo for
anyone this works for. And if it doesn't, the loss is roughly
equivalent to the usefulness of the old completion script, i.e. "not
much". It's also a *much* more interesting starting point for anyone
wishing to improve upon.
---
 completion/notmuch-completion.bash |  333 ++++++++++++++++++++++++++++--------
 1 file changed, 262 insertions(+), 71 deletions(-)
 rewrite completion/notmuch-completion.bash (66%)

diff --git a/completion/notmuch-completion.bash b/completion/notmuch-completion.bash
dissimilarity index 66%
index 8665268..cbd10aa 100644
--- a/completion/notmuch-completion.bash
+++ b/completion/notmuch-completion.bash
@@ -1,71 +1,262 @@
-# Bash completion for notmuch
-#
-# Copyright © 2009 Carl Worth
-#
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see http://www.gnu.org/licenses/ .
-#
-# Author: Carl Worth <cworth@cworth.org>
-#
-# Based on "notmuch help" as follows:
-#
-# Usage: notmuch <command> [args...]
-#
-# Where <command> and [args...] are as follows:
-#
-#	setup
-#
-#	new
-#
-#	search [options] <search-term> [...]
-#
-#	show <search-terms>
-#
-#	reply <search-terms>
-#
-#	tag +<tag>|-<tag> [...] [--] <search-terms> [...]
-#
-#	dump [<filename>]
-#
-#	restore <filename>
-#
-#	help [<command>]
-
-_notmuch()
-{
-    local current previous commands help_options
-
-    previous=${COMP_WORDS[COMP_CWORD-1]}
-    current="${COMP_WORDS[COMP_CWORD]}"
-
-    commands="setup new search show reply tag dump restore help"
-    help_options="setup new search show reply tag dump restore search-terms"
-    search_options="--max-threads= --first= --sort="
-
-    COMPREPLY=()
-
-    case $COMP_CWORD in
-        1)
-            COMPREPLY=( $(compgen -W "${commands}" -- ${current}) ) ;;
-        2)
-            case $previous in
-                help)
-                    COMPREPLY=( $(compgen -W "${help_options}" -- ${current}) ) ;;
-                search)
-                    COMPREPLY=( $(compgen -W "${search_options}" -- ${current}) ) ;;
-            esac
-            ;;
-    esac
-}
-
-complete -o default -o bashdefault -F _notmuch notmuch
+# bash completion for notmuch                              -*- shell-script -*-
+#
+# Copyright © 2013 Jani Nikula
+#
+# Based on the bash-completion package:
+# http://bash-completion.alioth.debian.org/
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see http://www.gnu.org/licenses/ .
+#
+# Author: Jani Nikula <jani@nikula.org>
+#
+#
+# BUGS/TODO:
+#
+# Add space after an --option without parameter (e.g. reply --decrypt)
+# on completion.
+#
+# Do not complete other options immediately after an --option= which
+# has no keyword value (e.g. reply --format-version=N).
+#
+# Filename completions for all file parameters (e.g. dump
+# --output=FILE or even config set database.path).
+#
+# Do not define _notmuch_commands at the top level.
+#
+# Consider completing options only if the string being completed
+# begins with '-' (i.e. do not offer option completions on
+# e.g. notmuch search <TAB>).
+#
+
+_notmuch_commands="config count dump help new reply restore search setup show tag"
+
+_notmuch_config()
+{
+    local cur prev words cword split
+    _init_completion || return
+
+    case "${prev}" in
+	config)
+	    COMPREPLY=( $(compgen -W "get set list" -- ${cur}) )
+	    return
+	    ;;
+	get|set)
+	    COMPREPLY=( $(compgen -W "`notmuch config list | sed 's/=.*\$//'`" -- ${cur}) )
+	    return
+	    ;;
+    esac
+}
+
+_notmuch_count()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--output)
+	    COMPREPLY=( $( compgen -W "messages threads" -- "${cur}" ) )
+	    return
+	    ;;
+	--exclude)
+	    COMPREPLY=( $( compgen -W "true false" -- "${cur}" ) )
+	    return
+	    ;;
+    esac
+
+    local options="--output= --exclude="
+    compopt -o nospace
+    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+}
+
+_notmuch_dump()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--format)
+	    COMPREPLY=( $( compgen -W "sup batch-tag" -- "${cur}" ) )
+	    return
+	    ;;
+    esac
+
+    local options="--format= --output="
+    compopt -o nospace
+    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+}
+
+_notmuch_help()
+{
+    local cur prev words cword split
+    _init_completion || return
+
+    local help_topics="$_notmuch_commands hooks search-terms"
+    COMPREPLY=( $(compgen -W "${help_topics}" -- ${cur}) )
+}
+
+_notmuch_new()
+{
+    local cur prev words cword split
+    _init_completion || return
+
+    local options="--no-hooks"
+    COMPREPLY=( $(compgen -W "${options}" -- ${cur}) )
+}
+
+_notmuch_reply()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--format)
+	    COMPREPLY=( $( compgen -W "default json sexp headers-only" -- "${cur}" ) )
+	    return
+	    ;;
+	--reply-to)
+	    COMPREPLY=( $( compgen -W "all sender" -- "${cur}" ) )
+	    return
+	    ;;
+    esac
+
+    local options="--format= --format-version= --reply-to= --decrypt"
+    compopt -o nospace
+    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+}
+
+_notmuch_restore()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--format)
+	    COMPREPLY=( $( compgen -W "sup batch-tag auto" -- "${cur}" ) )
+	    return
+	    ;;
+    esac
+
+    local options="--format= --accumulate --input="
+    compopt -o nospace
+    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+}
+
+_notmuch_search()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--format)
+	    COMPREPLY=( $( compgen -W "json sexp text text0" -- "${cur}" ) )
+	    return
+	    ;;
+	--output)
+	    COMPREPLY=( $( compgen -W "summary threads messages files tags" -- "${cur}" ) )
+	    return
+	    ;;
+	--sort)
+	    COMPREPLY=( $( compgen -W "newest-first oldest-first" -- "${cur}" ) )
+	    return
+	    ;;
+	--exclude)
+	    COMPREPLY=( $( compgen -W "true false flag" -- "${cur}" ) )
+	    return
+	    ;;
+    esac
+
+    local options="--format= --output= --sort= --offset= --limit= --exclude="
+    compopt -o nospace
+    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+}
+
+# N/A
+# _notmuch_setup()
+# {
+# }
+
+_notmuch_show()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--entire-thread)
+	    COMPREPLY=( $( compgen -W "true false" -- "${cur}" ) )
+	    return
+	    ;;
+	--format)
+	    COMPREPLY=( $( compgen -W "text json sexp mbox raw" -- "${cur}" ) )
+	    return
+	    ;;
+	--exclude|--body)
+	    COMPREPLY=( $( compgen -W "true false" -- "${cur}" ) )
+	    return
+	    ;;
+    esac
+
+    local options="--entire-thread= --format= --exclude= --body= --format-version= --part= --verify --decrypt"
+    compopt -o nospace
+    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+}
+
+_notmuch_tag()
+{
+    local cur prev words cword split
+    # handle tags with colons and equal signs
+    _init_completion -n := || return
+
+    case "${cur}" in
+	+*) COMPREPLY=( $(compgen -P "+" -W "`notmuch search --output=tags \*`" -- ${cur##+}) );;
+	-*) COMPREPLY=( $(compgen -P "-" -W "`notmuch search --output=tags \*`" -- ${cur##-}) );;
+    esac
+    # handle tags with colons
+    __ltrim_colon_completions "${cur}"
+}
+
+_notmuch()
+{
+    local arg cur prev words cword split
+    _init_completion || return
+
+    COMPREPLY=()
+
+    # subcommand
+    _get_first_arg
+
+    # complete --help option like the subcommand
+    if [ -z "${arg}" -a "${prev}" = "--help" ]; then
+	arg="help"
+    fi
+
+    if [ -z "${arg}" ]; then
+	# top level completion
+	local top_options="--help --version"
+	case "${cur}" in
+	    -*) COMPREPLY=( $(compgen -W "${top_options}" -- ${cur}) ) ;;
+	    *) COMPREPLY=( $(compgen -W "${_notmuch_commands}" -- ${cur}) ) ;;
+	esac
+    else
+	# complete using _notmuch_subcommand if one exist
+	local completion_func="_notmuch_${arg//-/_}"
+	declare -f $completion_func >/dev/null && $completion_func
+    fi
+} &&
+complete -F _notmuch notmuch
-- 
1.7.10.4

^ permalink raw reply related	[flat|nested] 3+ messages in thread

* [PATCH v2] completion: complete bash completion rewrite
  2013-03-02 13:59 [PATCH] completion: complete bash completion rewrite Jani Nikula
@ 2013-03-03 20:59 ` Jani Nikula
  2013-03-29 13:28   ` David Bremner
  0 siblings, 1 reply; 3+ messages in thread
From: Jani Nikula @ 2013-03-03 20:59 UTC (permalink / raw)
  To: notmuch

Rewrite the bash completion script to actually do something
useful. Supported completions:

* All the notmuch commands, command line arguments, and values for
  keyword arguments.

* Tags after + and - in 'notmuch tag'.

* Config options in 'notmuch config', and some config option values.

* Search prefixes in all commands that use search terms.

* Tags after tag: prefix in search terms.

* User's email addresses after from: and to: in search terms.

This is all based on the bash-completion package [1], and will not
work without it.

[1] http://bash-completion.alioth.debian.org/

---

CAVEATS:

There may be dependencies on the version of the bash-completion
package. I do not know, and I don't have a huge interest in finding
out. That way lay dragons.

Regardless, I think this is a *huge* improvement on the status quo for
anyone this works for. And if it doesn't, the loss is roughly
equivalent to the usefulness of the old completion script, i.e. "not
much". It's also a *much* more interesting starting point for anyone
wishing to improve upon.
---
 completion/notmuch-completion.bash |  412 +++++++++++++++++++++++++++++-------
 1 file changed, 341 insertions(+), 71 deletions(-)
 rewrite completion/notmuch-completion.bash (66%)

diff --git a/completion/notmuch-completion.bash b/completion/notmuch-completion.bash
dissimilarity index 66%
index 8665268..7bd7745 100644
--- a/completion/notmuch-completion.bash
+++ b/completion/notmuch-completion.bash
@@ -1,71 +1,341 @@
-# Bash completion for notmuch
-#
-# Copyright © 2009 Carl Worth
-#
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see http://www.gnu.org/licenses/ .
-#
-# Author: Carl Worth <cworth@cworth.org>
-#
-# Based on "notmuch help" as follows:
-#
-# Usage: notmuch <command> [args...]
-#
-# Where <command> and [args...] are as follows:
-#
-#	setup
-#
-#	new
-#
-#	search [options] <search-term> [...]
-#
-#	show <search-terms>
-#
-#	reply <search-terms>
-#
-#	tag +<tag>|-<tag> [...] [--] <search-terms> [...]
-#
-#	dump [<filename>]
-#
-#	restore <filename>
-#
-#	help [<command>]
-
-_notmuch()
-{
-    local current previous commands help_options
-
-    previous=${COMP_WORDS[COMP_CWORD-1]}
-    current="${COMP_WORDS[COMP_CWORD]}"
-
-    commands="setup new search show reply tag dump restore help"
-    help_options="setup new search show reply tag dump restore search-terms"
-    search_options="--max-threads= --first= --sort="
-
-    COMPREPLY=()
-
-    case $COMP_CWORD in
-        1)
-            COMPREPLY=( $(compgen -W "${commands}" -- ${current}) ) ;;
-        2)
-            case $previous in
-                help)
-                    COMPREPLY=( $(compgen -W "${help_options}" -- ${current}) ) ;;
-                search)
-                    COMPREPLY=( $(compgen -W "${search_options}" -- ${current}) ) ;;
-            esac
-            ;;
-    esac
-}
-
-complete -o default -o bashdefault -F _notmuch notmuch
+# bash completion for notmuch                              -*- shell-script -*-
+#
+# Copyright © 2013 Jani Nikula
+#
+# Based on the bash-completion package:
+# http://bash-completion.alioth.debian.org/
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see http://www.gnu.org/licenses/ .
+#
+# Author: Jani Nikula <jani@nikula.org>
+#
+#
+# BUGS:
+#
+# Add space after an --option without parameter (e.g. reply --decrypt)
+# on completion.
+#
+
+_notmuch_user_emails()
+{
+    notmuch config get user.primary_email
+    notmuch config get user.other_email
+}
+
+_notmuch_search_terms()
+{
+    local cur prev words cword split
+    # handle search prefixes and tags with colons and equal signs
+    _init_completion -n := || return
+
+    case "${cur}" in
+	tag:*)
+	    COMPREPLY=( $(compgen -P "tag:" -W "`notmuch search --output=tags \*`" -- ${cur##tag:}) )
+	    ;;
+	to:*)
+	    COMPREPLY=( $(compgen -P "to:" -W "`_notmuch_user_emails`" -- ${cur##to:}) )
+	    ;;
+	from:*)
+	    COMPREPLY=( $(compgen -P "from:" -W "`_notmuch_user_emails`" -- ${cur##from:}) )
+	    ;;
+	*)
+	    local search_terms="from: to: subject: attachment: tag: id: thread: folder: date:"
+	    compopt -o nospace
+	    COMPREPLY=( $(compgen -W "${search_terms}" -- ${cur}) )
+	    ;;
+    esac
+    # handle search prefixes and tags with colons
+    __ltrim_colon_completions "${cur}"
+}
+
+_notmuch_config()
+{
+    local cur prev words cword split
+    _init_completion || return
+
+    case "${prev}" in
+	config)
+	    COMPREPLY=( $(compgen -W "get set list" -- ${cur}) )
+	    ;;
+	get|set)
+	    COMPREPLY=( $(compgen -W "`notmuch config list | sed 's/=.*\$//'`" -- ${cur}) )
+	    ;;
+	# these will also complete on config get, but we don't care
+	database.path)
+	    _filedir
+	    ;;
+	maildir.synchronize_flags)
+	    COMPREPLY=( $(compgen -W "true false" -- ${cur}) )
+	    ;;
+    esac
+}
+
+_notmuch_count()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--output)
+	    COMPREPLY=( $( compgen -W "messages threads" -- "${cur}" ) )
+	    return
+	    ;;
+	--exclude)
+	    COMPREPLY=( $( compgen -W "true false" -- "${cur}" ) )
+	    return
+	    ;;
+    esac
+
+    ! $split &&
+    case "${cur}" in
+	-*)
+	    local options="--output= --exclude="
+	    compopt -o nospace
+	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+	    ;;
+	*)
+	    _notmuch_search_terms
+	    ;;
+    esac
+}
+
+_notmuch_dump()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--format)
+	    COMPREPLY=( $( compgen -W "sup batch-tag" -- "${cur}" ) )
+	    return
+	    ;;
+	--output)
+	    _filedir
+	    return
+	    ;;
+    esac
+
+    ! $split &&
+    case "${cur}" in
+	-*)
+	    local options="--format= --output="
+	    compopt -o nospace
+	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+	    ;;
+	*)
+	    _notmuch_search_terms
+	    ;;
+    esac
+}
+
+_notmuch_new()
+{
+    local cur prev words cword split
+    _init_completion || return
+
+    case "${cur}" in
+	-*)
+	    local options="--no-hooks"
+	    COMPREPLY=( $(compgen -W "${options}" -- ${cur}) )
+	    ;;
+    esac
+}
+
+_notmuch_reply()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--format)
+	    COMPREPLY=( $( compgen -W "default json sexp headers-only" -- "${cur}" ) )
+	    return
+	    ;;
+	--reply-to)
+	    COMPREPLY=( $( compgen -W "all sender" -- "${cur}" ) )
+	    return
+	    ;;
+    esac
+
+    ! $split &&
+    case "${cur}" in
+	-*)
+	    local options="--format= --format-version= --reply-to= --decrypt"
+	    compopt -o nospace
+	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+	    ;;
+	*)
+	    _notmuch_search_terms
+	    ;;
+    esac
+}
+
+_notmuch_restore()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--format)
+	    COMPREPLY=( $( compgen -W "sup batch-tag auto" -- "${cur}" ) )
+	    return
+	    ;;
+	--input)
+	    _filedir
+	    return
+	    ;;
+    esac
+
+    ! $split &&
+    case "${cur}" in
+	-*)
+	    local options="--format= --accumulate --input="
+	    compopt -o nospace
+	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+	    ;;
+    esac
+}
+
+_notmuch_search()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--format)
+	    COMPREPLY=( $( compgen -W "json sexp text text0" -- "${cur}" ) )
+	    return
+	    ;;
+	--output)
+	    COMPREPLY=( $( compgen -W "summary threads messages files tags" -- "${cur}" ) )
+	    return
+	    ;;
+	--sort)
+	    COMPREPLY=( $( compgen -W "newest-first oldest-first" -- "${cur}" ) )
+	    return
+	    ;;
+	--exclude)
+	    COMPREPLY=( $( compgen -W "true false flag" -- "${cur}" ) )
+	    return
+	    ;;
+    esac
+
+    ! $split &&
+    case "${cur}" in
+	-*)
+	    local options="--format= --output= --sort= --offset= --limit= --exclude="
+	    compopt -o nospace
+	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+	    ;;
+	*)
+	    _notmuch_search_terms
+	    ;;
+    esac
+}
+
+_notmuch_show()
+{
+    local cur prev words cword split
+    _init_completion -s || return
+
+    $split &&
+    case "${prev}" in
+	--entire-thread)
+	    COMPREPLY=( $( compgen -W "true false" -- "${cur}" ) )
+	    return
+	    ;;
+	--format)
+	    COMPREPLY=( $( compgen -W "text json sexp mbox raw" -- "${cur}" ) )
+	    return
+	    ;;
+	--exclude|--body)
+	    COMPREPLY=( $( compgen -W "true false" -- "${cur}" ) )
+	    return
+	    ;;
+    esac
+
+    ! $split &&
+    case "${cur}" in
+	-*)
+	    local options="--entire-thread= --format= --exclude= --body= --format-version= --part= --verify --decrypt"
+	    compopt -o nospace
+	    COMPREPLY=( $(compgen -W "$options" -- ${cur}) )
+	    ;;
+	*)
+	    _notmuch_search_terms
+	    ;;
+    esac
+}
+
+_notmuch_tag()
+{
+    local cur prev words cword split
+    # handle tags with colons and equal signs
+    _init_completion -n := || return
+
+    case "${cur}" in
+	+*)
+	    COMPREPLY=( $(compgen -P "+" -W "`notmuch search --output=tags \*`" -- ${cur##+}) )
+	    ;;
+	-*)
+	    COMPREPLY=( $(compgen -P "-" -W "`notmuch search --output=tags \*`" -- ${cur##-}) )
+	    ;;
+	*)
+	    _notmuch_search_terms
+	    return
+	    ;;
+    esac
+    # handle tags with colons
+    __ltrim_colon_completions "${cur}"
+}
+
+_notmuch()
+{
+    local _notmuch_commands="config count dump help new reply restore search setup show tag"
+    local arg cur prev words cword split
+    _init_completion || return
+
+    COMPREPLY=()
+
+    # subcommand
+    _get_first_arg
+
+    # complete --help option like the subcommand
+    if [ -z "${arg}" -a "${prev}" = "--help" ]; then
+	arg="help"
+    fi
+
+    if [ -z "${arg}" ]; then
+	# top level completion
+	local top_options="--help --version"
+	case "${cur}" in
+	    -*) COMPREPLY=( $(compgen -W "${top_options}" -- ${cur}) ) ;;
+	    *) COMPREPLY=( $(compgen -W "${_notmuch_commands}" -- ${cur}) ) ;;
+	esac
+    elif [ "${arg}" = "help" ]; then
+	# handle help command specially due to _notmuch_commands usage
+	local help_topics="$_notmuch_commands hooks search-terms"
+	COMPREPLY=( $(compgen -W "${help_topics}" -- ${cur}) )
+    else
+	# complete using _notmuch_subcommand if one exist
+	local completion_func="_notmuch_${arg//-/_}"
+	declare -f $completion_func >/dev/null && $completion_func
+    fi
+} &&
+complete -F _notmuch notmuch
-- 
1.7.10.4

^ permalink raw reply related	[flat|nested] 3+ messages in thread

* Re: [PATCH v2] completion: complete bash completion rewrite
  2013-03-03 20:59 ` [PATCH v2] " Jani Nikula
@ 2013-03-29 13:28   ` David Bremner
  0 siblings, 0 replies; 3+ messages in thread
From: David Bremner @ 2013-03-29 13:28 UTC (permalink / raw)
  To: Jani Nikula, notmuch

Jani Nikula <jani@nikula.org> writes:

> Rewrite the bash completion script to actually do something
> useful. Supported completions:
>
> * All the notmuch commands, command line arguments, and values for
>   keyword arguments.
It seems to do what it says on the box. The bash code look OK, although
I'm probably not as fussy or expert as some.

> ---
>
> CAVEATS:
>
> There may be dependencies on the version of the bash-completion
> package. I do not know, and I don't have a huge interest in finding
> out. That way lay dragons.

I pushed this.

Maybe we should just document what versions of bash-completion it is
tested with. I tested it with bash-completion 2.0. 

Could you make a followup patch with
something for completion/README and a line or so for NEWS?

^ permalink raw reply	[flat|nested] 3+ messages in thread

end of thread, other threads:[~2013-03-29 13:28 UTC | newest]

Thread overview: 3+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2013-03-02 13:59 [PATCH] completion: complete bash completion rewrite Jani Nikula
2013-03-03 20:59 ` [PATCH v2] " Jani Nikula
2013-03-29 13:28   ` David Bremner

Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).